/*
 * Copyright (c) 2019, 2020, Oracle and/or its affiliates. All rights reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 * This code is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 2 only, as
 * published by the Free Software Foundation.  Oracle designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Oracle in the LICENSE file that accompanied this code.
 *
 * This code is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * version 2 for more details (a copy is included in the LICENSE file that
 * accompanied this code).
 *
 * You should have received a copy of the GNU General Public License version
 * 2 along with this work; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
 * or visit www.oracle.com if you need additional information or have any
 * questions.
 */


#ifndef WINSYSINFO_H
#define WINSYSINFO_H

#include "SysInfo.h"


//
// Windows specific SysInfo.
//
namespace SysInfo {
    // gets Windows System folder. A typical path is C:\Windows\System32.
    tstring getSystem32Dir();

    // returns full path to msiexec.exe executable
    tstring getWIPath();

    // Returns handle of the current module (exe or dll).
    // The function assumes this code is statically linked to the module.
    HMODULE getCurrentModuleHandle();

    void setEnvVariable(const tstring& name, const tstring& value);
}


#endif // WINSYSINFO_H
